// Program.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "VtexFgen.h"

int _tmain(int argc, _TCHAR* argv[])
{
	ViStatus status = VI_SUCCESS;
	ViSession session = VI_NULL;

	// Driver identity (session not required)
	//
	ViChar prefix[1024];
	status = VtexFgen_GetAttributeViString(VI_NULL, VI_NULL, VTEXFGEN_ATTR_SPECIFIC_DRIVER_PREFIX, 1024, prefix);
	assert(status == VI_SUCCESS);
	printf("Prefix: %s\n", prefix);

	ViChar revision[1024];
	status = VtexFgen_GetAttributeViString(VI_NULL, VI_NULL, VTEXFGEN_ATTR_SPECIFIC_DRIVER_REVISION, 1024, revision);
	assert(status == VI_SUCCESS);
	printf("Revision: %s\n", revision);

	ViChar vendor[1024];
	status = VtexFgen_GetAttributeViString(VI_NULL, VI_NULL, VTEXFGEN_ATTR_SPECIFIC_DRIVER_VENDOR, 1024, vendor);
	assert(status == VI_SUCCESS);
	printf("Vendor: %s\n", vendor);

	ViChar description[1024];
	status = VtexFgen_GetAttributeViString(VI_NULL, VI_NULL, VTEXFGEN_ATTR_SPECIFIC_DRIVER_DESCRIPTION, 1024, description);
	assert(status == VI_SUCCESS);
	printf("Description: %s\n", description);

	// Initialize the connection to the instrument
	//
	status = VtexFgen_InitWithOptions("TCPIP::192.168.0.12::INSTR", VI_FALSE, VI_FALSE, "Cache=true, RangeCheck=true, Simulate=true, DriverSetup=slots=(2=ex1200_3608)", &session);
		//"QueryInstrStatus=true, Cache=true, RangeCheck=true, Simulate=false, Trace=false", &session);
	assert(status == VI_SUCCESS);
	assert(session != VI_NULL);

	if (session != VI_NULL)
	{
		// Driver identity (session required)
		//
		ViChar instModel[1024];
		status = VtexFgen_GetAttributeViString(session, VI_NULL, VTEXFGEN_ATTR_INSTRUMENT_MODEL, 1024, instModel);
		assert(status == VI_SUCCESS);
		printf("InstrumentModel: %s\n", instModel);

		ViChar instFirmwareRevision[1024];
		status = VtexFgen_GetAttributeViString(session, VI_NULL, VTEXFGEN_ATTR_INSTRUMENT_FIRMWARE_REVISION, 1024, instFirmwareRevision);
		assert(status == VI_SUCCESS);
		printf("InstrumentFirmwareRevision: %s\n", instFirmwareRevision);

		ViChar instManufacturer[1024];
		status = VtexFgen_GetAttributeViString(session, VI_NULL, VTEXFGEN_ATTR_INSTRUMENT_MANUFACTURER, 1024, instManufacturer);
		assert(status == VI_SUCCESS);
		printf("InstrumentManufacturer: %s\n", instManufacturer);

		// TODO: Exercise driver functions and attributes

		// Check instrument for errors
		//
		ViInt32 errorNum = -1;
		ViChar errorMsg[1024];
		printf("\n");
		while (errorNum != 0)
		{
			status = VtexFgen_error_query(session, &errorNum, errorMsg);
			assert(status == VI_SUCCESS);
			printf("ErrorQuery: %d, %s\n", errorNum, errorMsg);
		}

		// Close the connection to the instrument
		//
		status = VtexFgen_close(session);
		assert(status == VI_SUCCESS);
		session = VI_NULL;
	}

	printf("\nDone - Press Enter to Exit");
	getchar();

	return 0;
}
